%define real_name 8821au-20210708

%global commit eb5cee534d9fa58198c687bd721ea03fdd8cca30
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global gitdate 20250205

Summary: Linux Driver for USB WiFi Adapters that are based on the RTL8811AU and RTL8821AU Chipsets
Name: dkms-8821au
Version: 5.12.5.2
Release: 2.git%{gitdate}%{?dist}
License: GPL-2.0-only
Group: System Environment/Kernel
URL: https://github.com/morrownr/8821au-20210708
Source0: https://github.com/morrownr/8821au-20210708/archive/%{commit}/8821au-20210708-%{shortcommit}.tar.gz
Source1: dkms-8821au.metainfo.xml

BuildArch: noarch
Requires: gcc
Requires: make
Requires: kernel-devel
Requires(post): dkms
Requires(preun): dkms

%description
Linux Driver for USB WiFi Adapters that are based on the RTL8811AU and RTL8821AU Chipsets

%prep
%setup -q -n %{real_name}-%{commit}

%build

%install
%{__rm} -rf %{buildroot}

#install appstream metainfo
%__install -Dm0644 %{SOURCE1} -t %{buildroot}%{_metainfodir}

%define dkms_name 8821au
%define dkms_vers %{version}-%{release}
%define quiet -q

# Kernel module sources install for dkms
%{__mkdir_p} %{buildroot}%{_sysconfdir}/modprobe.d/
%{__cp} 8821au.conf %{buildroot}%{_sysconfdir}/modprobe.d/
%{__mkdir_p} %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{__cp} -a core hal include os_dep platform Makefile Kconfig %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/

# Configuration for dkms
%{__cat} <<'EOF' >%{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/dkms.conf
PACKAGE_NAME=%{dkms_name}
PACKAGE_VERSION=%{dkms_vers}
MAKE[0]="'make' -j$(nproc) KVER=${kernelver}"
CLEAN[0]="'make' clean"
BUILT_MODULE_NAME[0]=%{dkms_name}
DEST_MODULE_LOCATION[0]=/kernel/drivers/net
AUTOINSTALL="YES"
EOF

%post
# Add to DKMS registry
dkms --rpm_safe_upgrade add -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
# Rebuild and make available for the currenty running kernel
dkms --rpm_safe_upgrade build -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
dkms --rpm_safe_upgrade install -m %{dkms_name} -v %{dkms_vers} %{?quiet} --force || :

%preun
# Remove all versions from DKMS registry
dkms --rpm_safe_upgrade remove -m %{dkms_name} -v %{dkms_vers} %{?quiet} --all || :

%files
%defattr(-, root, root, -)
%doc README.md docs/Concurrent_Mode.md supported-device-IDs
%license LICENSE
%{_sysconfdir}/modprobe.d/8821au.conf
%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{_metainfodir}/*.metainfo.xml

%changelog
* Wed Feb 05 2025 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20250205
- Update README.md
- support for kernel 6.13
- update installation script
- explain new in-kernel driver

* Sat Jun 15 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20240615
- update README

* Wed May 29 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20240529
- Update README.md
- add message about new driver
- minor updates

* Sat Mar 30 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20240330
- update docs

* Tue Mar 26 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20240326
- Merge pull request #126 from 5kft/kernel-v6.9-changes

* Tue Mar 19 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20240319
- update scripts and docs
- fix UBSAN: array-index-out-of-bounds

* Fri Feb 02 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20240202
- minor update

* Mon Jan 22 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20240122
- Merge pull request #122 from 5kft/kernel-v6.8-changes
- minor updates to docs and scripts

* Fri Dec 01 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20231201
- add gcc-13 flags
- update docs
- Merge pull request #114 from 5kft/kernel-v6.7-changes

* Mon Nov 06 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20231106
- update scripts and documentation
- minor doc update

* Mon Sep 11 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20230911
- Merge pull request #101 from Mikesco3/main
- fix support for a backport from kernel 6.5
- Merge branch 'main' of https://github.com/morrownr/8821au-20210708
- fix backport from kernel 6.5
- trying to fix a kernel 6.5 backport
- Merge pull request #96 from 5kft/kernel-v6.5-rc1
- Merge pull request #84 from gemesa/build-ci
- Merge pull request #83 from gemesa/markdown-link
- minor update
- Merge branch 'main' of https://github.com/morrownr/8821au-20210708
- Log spam with start_addr, buffer_size
- Merge pull request #78 from gemesa/shellcheck
- Merge pull request #77 from gemesa/ci-rename

* Sun Mar 12 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20230312
- Merge pull request #74 from gemesa/ci
- Merge pull request #75 from 5kft/kernel-v6.3-rc1
- improvements to the scripts and docs
- various -  mostly cleanup
- minor updates

* Thu Feb 09 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20230209
- cleanup-major upgrade nearly complete
- various fixes, mostly monitor mode related
- Merge pull request #73 from gemesa/gitignore
- update scripts and documentation
- Merge pull request #72 from gemesa/readme
- Merge pull request #71 from gemesa/fedora-6.1
- minor update
- minor updates
- update to various supporting files

* Thu Dec 22 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20221222
- major upgrade to scripts and docs
- minor updates
- work on secure boot support for Fedora
- minor update
- minor update
- minor update
- minor update

* Sat Nov 12 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20221112
- Use parallel build

* Mon Nov 07 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20221107
- work on k5.15 support
- add Secure Boot support to Makefile
- minor updates
- update install and remove scripts

* Mon Oct 17 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-2.git20221017
- update makefile for gcc-12

* Mon Oct 17 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-1.git20221017
- Merge pull request #56 from 5kft/kernel-v6.1-rc1

* Mon Oct 10 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-1.git20221010
- Merge remote-tracking branch 'origin/main'
- documentation update
- Update README.md
- various updates
- minor updates
- Merge pull request #50 from KirMozor/main

* Thu Aug 18 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-1.git20220818
- support for kernels 5.19.2 and 6.0
- minor update
- update README.md
- minor updates
- fix cosmetic installation script issue
- update ARM scripts
- documentation update

* Fri May 27 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-1.git20220527
- update README.md
- add no-dkms script files
- Merge branch 'main' of https://github.com/morrownr/8821au-20210708 into main
- add -Wno-implicit-fallthrough to Makfile
- documentation update
- Merge pull request #33 from Zeno-sole/main

* Fri Mar 18 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-1.git20220318
- updated Access Point document

* Thu Feb 17 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-1.git20220217
- minor updates

* Mon Feb 14 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.12.5.2-1.git20220214
- documentation updates
- various documentation updates
- change a printk to _RTW_DBG to avoid printing garbage logs

* Wed Jan 26 2022 Paweł Marciniak <pmarciniak@lodz.home.pl> - 5.12.5.2-1.git20220126
- Version 5.12.5.2 commit 76c6e06deb5a91ad0e5967b248a21a59e672fef6

* Mon Jan 24 2022 Paweł Marciniak <pmarciniak@lodz.home.pl> - 5.12.5.2-1.git20220124
- Version 5.12.5.2 commit 2861ddab28264bc3d92dd4da8117c6936d5c9ca6

* Sun Nov 21 2021 Paweł Marciniak <pmarciniak@lodz.home.pl> - 5.12.5.2-1.git20211222
- Version 5.12.5.2 commit 40dde9930cfc1dd2f004df06a95276ab61029364 

* Sun Nov 21 2021 Paweł Marciniak <pmarciniak@lodz.home.pl> - 5.12.5.2-1.git20211122
- Version 5.12.5.2 commit bb0ee5ab70b57755675f0bb6f08d525582515b3b

* Sun Nov 21 2021 Paweł Marciniak <pmarciniak@lodz.home.pl> - 5.12.5.2-1
- Version 5.12.5.2 commit 13647de67396d3c88c405c260c8adeb8e19221c8
